<?php
function check_user_rights(){
	// CHECK LES DROITS
}
function run_resource_method(){

	$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
	include $path.'/api/lib/api_common.php';

	global $urlParameters;

	$id = null;
	$type=null;
	if (!empty($urlParameters))
	{
		$statenode = array_search('node', $urlParameters);
		$stateservice = array_search('service', $urlParameters);
		$stategroupnode = array_search('groupnode', $urlParameters);

		if($statenode!==false)
		{
			$type="node";
			$key_service=$statenode;
		}
		if($stateservice!==false)
		{
			$type="service";
			$key_service=$stateservice;
		}
		if($stategroupnode!==false)
		{
			$type="groupnode";
			$key_service=$stategroupnode;
		}

		if(isset($urlParameters[$key_service+1]) && !empty($urlParameters[$key_service+1]))
		{
			$id = $urlParameters[$key_service+1];
		}
	}

	try
	{
		if($type=="node")
		{
			if($id==null) $arr = Model_esia::countStateAllNode($dbconnection,$user->getId());
			else $arr = Model_esia::countNodeState($dbconnection,$id);
			$ret = $arr;
		}
		elseif($type=="service")
		{
			//Calcul du nombre de service "actifs" (tableau en haut à droite)
			$arr_error['ok']=0;
			$arr_error['OK']=0;
			$arr_error["warning"]=0;
			$arr_error["critical"]=0;
			$arr_error["unknown"]=0;
			$arr_error["maintenance"]=0;
			$arr_error["pending"]=0;
			$li=Model_esia::countServiceAllState($dbconnection,$user->getId());
			$totser = 0;
			foreach($li as $k => $v)
			{
				$arr_error[$k]= intval($v);
			}
			$arr_error['ok']=$arr_error['OK'];
			$arr_error['acquitted'] =  $arr_error['pending'];
            $arr_error['pending']=$arr_error['waiting'];
            $arr_error['acquitted'] -=  $arr_error['maintenance']; //A cause d'un comportement douteux dans la fonction Model_esia::countServiceAllState. A vérifier/changer
			unset($arr_error['OK']);
			unset($arr_error['waiting']);
			$ret = $arr_error;
		}
		elseif($type=="groupnode")
		{
			//On récupère l'état des noeuds dans le parent et l'état des sous-groupes.
			/*$state=array();
			$state_parent = model_esia::getGroupNodeStates($dbconnection,$user->getId(),$id,false);

			print_r($state_parent);

			$state_child = model_esia::getGroupNodeStates($dbconnection,$user->getId(),$id,true);

			print_r($state_child);

			reset($state_parent);
			$state['ok'] = $state_parent[key($state_parent)]['ok'];
			$state['warning'] = $state_parent[key($state_parent)]['warning'];
			$state['critical'] = $state_parent[key($state_parent)]['critical'];
			$state['unknown'] = $state_parent[key($state_parent)]['unknown'];
			//$state['maintenance'] = $state_parent[key($state_parent)]['maintenance'];
			//On additionne les 2 tableau pour avoir l'état global d'un groupe
			foreach($state_child as $current)
			{
				$state['ok'] += $current['ok'];
				$state['warning'] += $current['warning'];
				$state['critical'] += $current['critical'];
				$state['unknown'] += $current['unknown'];
				//$state['maintenance'] += $current['maintenance'];
			}

			$globalState = "ok";
			if($state["critical"] > 0) { $globalState = "critical"; }
			else if ($state["warning"] > 0) { $globalState = "warning"; }
			else if ($state["unknown"] > 0) { $globalState = "unknown"; }
			//else if ($state["maintenance"] > 0) { $globalState = "maintenance"; }

			$ret=$state;
			*/
			$state = array();
			$list_node_grp=array();
			$nodegroup=$id;
			if($nodegroup==null)
			{
				$NodeList = Model_esia::newgetNodeList($dbconnection,$user->getId(),'noGroup',Model_esia::NODE_INSTANCE);
			}
			else
			{
				$NodeList = Model_esia::newgetNodeList($dbconnection,$user->getId(),$nodegroup,Model_esia::NODE_INSTANCE);
			}
			foreach($NodeList as $node)
			{
				//on récupère l'état du noeud
				$NodeState = Model_esia::countNodeState($dbconnection, $node->getId());
				$list_node_grp[]=array(
						'id'=>$node->getId(),
						'ok'=>$NodeState['OK'],'warning'=>$NodeState['warning'],'critical'=>$NodeState['critical'],'unknown'=>$NodeState['unknown']);
			}

			//On récupérer l'arborescence des groupes
			//si nodeGroup est différents de null. On liste le groupe demandé ainsi que les sous-groupes
			$arrs = model_esia::getGroupNodeStates($dbconnection,$user->getId(),$nodegroup,true);
			$GROUP_NODE_STATE = $arrs;
			//prepare la resquete pour les GroupNodeStat
			foreach($GROUP_NODE_STATE as $top)
			{
					$tmp=null;
					$state='null';
					if(array_key_exists('ok', $top))
					{
						$state = array('ok'=>$top['ok'],'warning'=>$top['warning'],'critical'=>$top['critical'],'unknown'=>$top['unknown']);
					}
					else
					{
						$state = $top['status'];
					}
					//si le groupe est vide on ne l'affiche pas
					if(!is_groupServiceEmpty($state))
					{
						//lien vers le sous groupe
						$page_control="/node_index.php?nodegroup=".$top['id'];
						$list_node_grp[]=array('id'=>$top['id'],
												/*'name'=>$top['name'],
												'type'=>'aa_groupNode',
												'type_img'=>$ICONS['groupNode'],
												'description'=>'',
												'ip_address'=>'',
												'link'=>$page_control,*/
												'ok'=>$state['ok'],
												'warning'=>$state['warning'],
												'critical'=>$state['critical'],
												'unknown'=>$state['unknown']);
					}
			}
			//$ret=$list_node_grp;
			$state = array();
			foreach($list_node_grp as $current)
			{
				$state['ok'] += $current['ok'];
				$state['warning'] += $current['warning'];
				$state['critical'] += $current['critical'];
				$state['unknown'] += $current['unknown'];
				//$state['maintenance'] += $current['maintenance'];
			}

			$globalState = "ok";
			if($state["critical"] > 0) { $globalState = "critical"; }
			else if ($state["warning"] > 0) { $globalState = "warning"; }
			else if ($state["unknown"] > 0) { $globalState = "unknown"; }
			//else if ($state["maintenance"] > 0) { $globalState = "maintenance"; }
			$state['state']=$globalState;

			$ret=$state;
		}
		else
		{
			$arr = Model_esia::countNodeType($dbconnection,$user->getId(), Model_esia::NODE_COUNT_SERVICE_STATE);

			$total_node=0;
			$total_service=0;
			$total_ok=0;
			$total_warning=0;
			$total_critical=0;
			$total_unknown=0;

			foreach($arr as $key => $val)
			{
				$total_node = $total_node+$val['nbr_device'];
				$total_ok=$total_ok+$val['ok'];
				$total_warning=$total_warning+$val['warning'];
				$total_critical=$total_critical+$val['critical'];
				$total_unknown=$total_unknown+$val['unknown'];
			}

			$total_service = $total_ok+$total_warning+$total_critical+$total_unknown;

			$ret = array("total_node"=>$total_node,
					"total_service"=>$total_service,
					"total_node_type"=>count($arr),
					"total_ok"=>$total_ok,
					"total_war"=>$total_warning,
					"total_cri"=>$total_critical,
					"total_unk"=>$total_unknown);
		}

		if(empty($ret))
		{
			throw new  NotFoundResourceException ("No state");
		}
	}
	catch (Exception $e)
	{
		throw new  NotFoundResourceException ("Error state");
	}
	return $ret;
}

function is_groupServiceEmpty($state)
{
	$show =true;
	foreach($state as $key => $value)
	{
		if($value!=0)
		{
			$show=false;
			break;
		}
	}
	return $show;
}

?>
